# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudRun.V1alpha1.Model.IntOrString do
  @moduledoc """
  IntOrString is a type that can hold an int32 or a string. When used in JSON or YAML marshalling and unmarshalling, it produces or consumes the inner type. This allows you to have, for example, a JSON field that can accept a name or number.

  ## Attributes

  *   `intVal` (*type:* `integer()`, *default:* `nil`) - The int value.
  *   `strVal` (*type:* `String.t`, *default:* `nil`) - The string value.
  *   `type` (*type:* `integer()`, *default:* `nil`) - The type of the value.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :intVal => integer() | nil,
          :strVal => String.t() | nil,
          :type => integer() | nil
        }

  field(:intVal)
  field(:strVal)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.CloudRun.V1alpha1.Model.IntOrString do
  def decode(value, options) do
    GoogleApi.CloudRun.V1alpha1.Model.IntOrString.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudRun.V1alpha1.Model.IntOrString do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
