# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudRun.V1alpha1.Model.Job do
  @moduledoc """
  Job represents the configuration of a single job. A job an immutable resource that references a container image which is run to completion.

  ## Attributes

  *   `apiVersion` (*type:* `String.t`, *default:* `nil`) - Optional. APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources +optional
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Optional. Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds +optional
  *   `metadata` (*type:* `GoogleApi.CloudRun.V1alpha1.Model.ObjectMeta.t`, *default:* `nil`) - Optional. Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata +optional
  *   `spec` (*type:* `GoogleApi.CloudRun.V1alpha1.Model.JobSpec.t`, *default:* `nil`) - Optional. Specification of the desired behavior of a job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status +optional
  *   `status` (*type:* `GoogleApi.CloudRun.V1alpha1.Model.JobStatus.t`, *default:* `nil`) - Optional. Current status of a job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status +optional
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :apiVersion => String.t() | nil,
          :kind => String.t() | nil,
          :metadata => GoogleApi.CloudRun.V1alpha1.Model.ObjectMeta.t() | nil,
          :spec => GoogleApi.CloudRun.V1alpha1.Model.JobSpec.t() | nil,
          :status => GoogleApi.CloudRun.V1alpha1.Model.JobStatus.t() | nil
        }

  field(:apiVersion)
  field(:kind)
  field(:metadata, as: GoogleApi.CloudRun.V1alpha1.Model.ObjectMeta)
  field(:spec, as: GoogleApi.CloudRun.V1alpha1.Model.JobSpec)
  field(:status, as: GoogleApi.CloudRun.V1alpha1.Model.JobStatus)
end

defimpl Poison.Decoder, for: GoogleApi.CloudRun.V1alpha1.Model.Job do
  def decode(value, options) do
    GoogleApi.CloudRun.V1alpha1.Model.Job.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudRun.V1alpha1.Model.Job do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
