# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudRun.V1alpha1.Model.Probe do
  @moduledoc """
  Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.

  ## Attributes

  *   `failureThreshold` (*type:* `integer()`, *default:* `nil`) - Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. +optional
  *   `handler` (*type:* `GoogleApi.CloudRun.V1alpha1.Model.Handler.t`, *default:* `nil`) - The action taken to determine the health of a container
  *   `initialDelaySeconds` (*type:* `integer()`, *default:* `nil`) - Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional
  *   `periodSeconds` (*type:* `integer()`, *default:* `nil`) - How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. +optional
  *   `successThreshold` (*type:* `integer()`, *default:* `nil`) - Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness. Minimum value is 1. +optional
  *   `timeoutSeconds` (*type:* `integer()`, *default:* `nil`) - Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes +optional
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :failureThreshold => integer() | nil,
          :handler => GoogleApi.CloudRun.V1alpha1.Model.Handler.t() | nil,
          :initialDelaySeconds => integer() | nil,
          :periodSeconds => integer() | nil,
          :successThreshold => integer() | nil,
          :timeoutSeconds => integer() | nil
        }

  field(:failureThreshold)
  field(:handler, as: GoogleApi.CloudRun.V1alpha1.Model.Handler)
  field(:initialDelaySeconds)
  field(:periodSeconds)
  field(:successThreshold)
  field(:timeoutSeconds)
end

defimpl Poison.Decoder, for: GoogleApi.CloudRun.V1alpha1.Model.Probe do
  def decode(value, options) do
    GoogleApi.CloudRun.V1alpha1.Model.Probe.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudRun.V1alpha1.Model.Probe do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
