# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudRun.V1alpha1.Model.Quantity do
  @moduledoc """
  The view model of a single quantity, e.g. "800 MiB". Corresponds to https://github.com/kubernetes/kubernetes/blob/master/staging/src/k8s.io/apimachinery/pkg/api/resource/generated.proto

  ## Attributes

  *   `string` (*type:* `String.t`, *default:* `nil`) - Stringified version of the quantity, e.g., "800 MiB".
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :string => String.t() | nil
        }

  field(:string)
end

defimpl Poison.Decoder, for: GoogleApi.CloudRun.V1alpha1.Model.Quantity do
  def decode(value, options) do
    GoogleApi.CloudRun.V1alpha1.Model.Quantity.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudRun.V1alpha1.Model.Quantity do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
