# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudRun.V1alpha1.Model.VolumeMount do
  @moduledoc """
  VolumeMount describes a mounting of a Volume within a container.

  ## Attributes

  *   `mountPath` (*type:* `String.t`, *default:* `nil`) - Path within the container at which the volume should be mounted. Must not contain ':'.
  *   `mountPropagation` (*type:* `String.t`, *default:* `nil`) - mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationHostToContainer is used. This field is beta in 1.10. +optional
  *   `name` (*type:* `String.t`, *default:* `nil`) - This must match the Name of a Volume.
  *   `readOnly` (*type:* `boolean()`, *default:* `nil`) - Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false. +optional
  *   `subPath` (*type:* `String.t`, *default:* `nil`) - Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root). +optional
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :mountPath => String.t() | nil,
          :mountPropagation => String.t() | nil,
          :name => String.t() | nil,
          :readOnly => boolean() | nil,
          :subPath => String.t() | nil
        }

  field(:mountPath)
  field(:mountPropagation)
  field(:name)
  field(:readOnly)
  field(:subPath)
end

defimpl Poison.Decoder, for: GoogleApi.CloudRun.V1alpha1.Model.VolumeMount do
  def decode(value, options) do
    GoogleApi.CloudRun.V1alpha1.Model.VolumeMount.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudRun.V1alpha1.Model.VolumeMount do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
